// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Runner.pas' rev: 3.00

#ifndef RunnerHPP
#define RunnerHPP
#include <ShellAPI.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Runner
{
//-- type declarations -------------------------------------------------------
typedef System::Comp LargeInt;

class DELPHICLASS ERunnerError;
class PASCALIMPLEMENTATION ERunnerError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall ERunnerError(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall ERunnerError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall ERunnerError(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall ERunnerError(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall ERunnerError(const System::AnsiString Msg, int AHelpContext) : 
		Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall ERunnerError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall ERunnerError(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall ERunnerError(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~ERunnerError(void) { }
	
};

struct TAppInfo
{
	System::AnsiString Name;
	int Result;
	System::TDateTime Started;
	System::TDateTime Ended;
	System::Comp KernelTime;
	System::Comp UserTime;
} ;

class DELPHICLASS TWindowPosition;
class PASCALIMPLEMENTATION TWindowPosition : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	int FLeft;
	int FTop;
	int FWidth;
	int FHeight;
	void __fastcall SetLeft(int Value);
	void __fastcall SetTop(int Value);
	void __fastcall SetWidth(int Value);
	void __fastcall SetHeight(int Value);
	
public:
	__fastcall virtual TWindowPosition(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property int Left = {read=FLeft, write=SetLeft, nodefault};
	__property int Top = {read=FTop, write=SetTop, nodefault};
	__property int Width = {read=FWidth, write=SetWidth, nodefault};
	__property int Height = {read=FHeight, write=SetHeight, nodefault};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TWindowPosition(void) { }
	
};

enum TWindowShowState { wssHide, wssNormal, wssShowMinimized, wssShowMaximized, wssShowNoActivate, wssShow, 
	wssMinimize, wssShowMinNoActive, wssShowNA, wssRestore, wssShowDefault };

class DELPHICLASS TWaitTerminateThread;
class DELPHICLASS TRunner;
enum TProcessPriority { ppIdle, ppNormal, ppHigh, ppRealTime };

typedef void __fastcall (__closure *TAppNotifyEvent)(const TAppInfo &App);

class PASCALIMPLEMENTATION TRunner : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	System::AnsiString FFileToRun;
	TProcessPriority FPriority;
	TAppNotifyEvent FOnAppTerminate;
	TAppNotifyEvent FOnAppIdle;
	Classes::TStringList* FEnvironment;
	TWindowPosition* FPosition;
	TWindowShowState FShowState;
	int FProcessHandle;
	int FThreadHandle;
	int FProcessID;
	int FThreadID;
	System::AnsiString FParameters;
	_STARTUPINFOA StartupInfo;
	_PROCESS_INFORMATION ProcessInfo;
	void __fastcall SetFileToRun(const System::AnsiString Value);
	void __fastcall SetPriority(const TProcessPriority Value);
	void __fastcall SetOnAppTerminate(const TAppNotifyEvent Value);
	void __fastcall SetOnAppIdle(const TAppNotifyEvent Value);
	void __fastcall SetEnvironment(const Classes::TStringList* Value);
	void __fastcall SetPosition(const TWindowPosition* Value);
	void __fastcall SetShowState(const TWindowShowState Value);
	void __fastcall SetParameters(const System::AnsiString Value);
	
public:
	__fastcall virtual TRunner(Classes::TComponent* AOwner);
	__fastcall virtual ~TRunner(void);
	void __fastcall Run(void);
	void __fastcall Stop(void);
	void __fastcall Terminate(void);
	bool __fastcall GetTimes(System::TDateTime &Started, System::Comp &KernelTime, System::Comp &UserTime
		);
	int __fastcall GetHandle(void);
	__property int ProcessHandle = {read=FProcessHandle, nodefault};
	__property int ThreadHandle = {read=FThreadHandle, nodefault};
	__property int ProcessID = {read=FProcessID, nodefault};
	__property int ThreadID = {read=FThreadID, nodefault};
	
__published:
	__property System::AnsiString FileToRun = {read=FFileToRun, write=SetFileToRun};
	__property TProcessPriority Priority = {read=FPriority, write=SetPriority, nodefault};
	__property Classes::TStringList* Environment = {read=FEnvironment, write=SetEnvironment};
	__property TWindowPosition* Position = {read=FPosition, write=SetPosition};
	__property TWindowShowState ShowState = {read=FShowState, write=SetShowState, nodefault};
	__property System::AnsiString Parameters = {read=FParameters, write=SetParameters};
	__property TAppNotifyEvent OnAppTerminate = {read=FOnAppTerminate, write=SetOnAppTerminate};
	__property TAppNotifyEvent OnAppIdle = {read=FOnAppIdle, write=SetOnAppIdle};
};

class PASCALIMPLEMENTATION TWaitTerminateThread : public Classes::TThread 
{
	typedef Classes::TThread inherited;
	
private:
	int FProcessHandle;
	int FThreadHandle;
	TRunner* FRunner;
	TAppInfo FAppInfo;
	
protected:
	virtual void __fastcall Execute(void);
	void __fastcall SignalTermination(void);
	
public:
	__fastcall TWaitTerminateThread(int AProcessHandle, int AThreadHandle, TRunner* ARunner);
public:
	/* TThread.Destroy */ __fastcall virtual ~TWaitTerminateThread(void) { }
	
};

class DELPHICLASS TWaitIdleThread;
class PASCALIMPLEMENTATION TWaitIdleThread : public Classes::TThread 
{
	typedef Classes::TThread inherited;
	
private:
	int FHandle;
	TRunner* FRunner;
	TAppInfo FAppInfo;
	
protected:
	virtual void __fastcall Execute(void);
	void __fastcall SignalIdle(void);
	
public:
	__fastcall TWaitIdleThread(int AHandle, TRunner* ARunner);
public:
	/* TThread.Destroy */ __fastcall virtual ~TWaitIdleThread(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------

}	/* namespace Runner */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Runner;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// Runner
